<?php
// custom login for theme
// folder themes/theme_name/custom-login/
function fb_custom_login() {
	if (function_exists('wp_admin_css_color')) {
		echo '<link rel="stylesheet" type="text/css" href="' . get_bloginfo('template_directory') . '/custom-login/custom-login25.css" />';
	} else {
		echo '<link rel="stylesheet" type="text/css" href="' . get_bloginfo('template_directory') . '/custom-login/custom-login23.css" />';
	}
}

add_action('login_head', 'fb_custom_login');

// commenttemplate
function fb_comments_template( $file = '/comments.php' ) {
	global $wp_query, $withcomments, $post, $wpdb, $id, $comment, $user_login, $user_ID, $user_identity;

	if ( ! (is_home() || is_single() || is_page() || $withcomments) )
		return;

	$req = get_option('require_name_email');
	$commenter = wp_get_current_commenter();
	extract($commenter, EXTR_SKIP);

	// TODO: Use API instead of SELECTs.
	if ( $user_ID) {
		$comments = $wpdb->get_results("SELECT * FROM $wpdb->comments WHERE comment_post_ID = '$post->ID' AND (comment_approved = '1' OR ( user_id = '$user_ID' AND comment_approved = '0' ) )  ORDER BY comment_date");
	} else if ( empty($comment_author) ) { 
		$comments = $wpdb->get_results("SELECT * FROM $wpdb->comments WHERE comment_post_ID = '$post->ID' AND comment_approved = '1' ORDER BY comment_date");
	} else {
		$author_db = $wpdb->escape($comment_author);
		$email_db  = $wpdb->escape($comment_author_email);
		$comments = $wpdb->get_results("SELECT * FROM $wpdb->comments WHERE comment_post_ID = '$post->ID' AND ( comment_approved = '1' OR ( comment_author = '$author_db' AND comment_author_email = '$email_db' AND comment_approved = '0' ) ) ORDER BY comment_date");
	}

	// keep $comments for legacy's sake (remember $table*? ;) )
	$comments = $wp_query->comments = apply_filters( 'comments_array', $comments, $post->ID );
	$wp_query->comment_count = count($wp_query->comments);

	define('COMMENTS_TEMPLATE', true);
	$include = apply_filters('comments_template', TEMPLATEPATH . $file );
	if ( file_exists( $include ) )
		require( $include );
	else
		require( ABSPATH . 'wp-content/themes/default/comments.php');
}


// read EXIF-Data
function fb_read_write_exif_data() {
 
			$image = fb_meta_image();
			if ($image != '') {
				error_reporting(0);
				$image = get_settings('home') . "/wp-content/uploads/" . $image;
				$exif = exif_read_data($image, 0 , true);
				
				if(isset($exif["EXIF"]["DateTimeOriginal"])) {
					$fbdateoriginal = str_replace(":","-",substr($exif["EXIF"]["DateTimeOriginal"], 0, 10));
					$fbtimeoriginal = substr($exif["EXIF"]["DateTimeOriginal"], 10);
					print __('Datum:', 'photoblogfb') . " {$fbdateoriginal}";
					print __(' &middot; Uhrzeit:', 'photoblogfb') . " {$fbtimeoriginal}";
					print "<br />\n";
				}

				if(isset($exif["EXIF"]["FNumber"])) {
					list($num,$den) = explode("/",$exif["EXIF"]["FNumber"]);
					$fbaperture  = "F/" . ($num/$den);
					print __('Blende:', 'photoblogfb') . " {$fbaperture}";;
				}
				
				if(isset($exif["EXIF"]["ExposureTime"])) {
					list($num, $den) = explode("/", $exif["EXIF"]["ExposureTime"]);
					if ($num!=1) {
						$fbexposure = "{$num}s";
						print __(' &middot; Belichtungsdauer:', 'photoblogfb') . " {$fbexposure}";
					} else {
						$den = $den/$num;
						$fbexposure = "1/{$den}s";
						print __(' &middot; Belichtungsdauer:', 'photoblogfb') . " {$fbexposure}";
					}
				}
				
				if(isset($exif["EXIF"]["FocalLength"])) {
					list($num, $den) = explode("/", $exif["EXIF"]["FocalLength"]);
					$fbfocallength  = ($num/$den) . "mm";
					print __(' &middot; Brennweite:', 'photoblogfb') . " {$fbfocallength}";
				}
				
				if(isset($exif["EXIF"]["FocalLengthIn35mmFilm"])) {
					$fbfbfocallength35 = $exif["EXIF"]["FocalLengthIn35mmFilm"];
					print __(' &middot; (Brennweite 35mm:', 'photoblogfb') . " {$fbfbfocallength35}" . __('mm)');
				}
				
				if (isset($exif["EXIF"]["ISOSpeedRatings"])) {
					print __(' &middot; ISO:', 'photoblogfb') . " {$exif["EXIF"]["ISOSpeedRatings"]}";
				}					

				if(isset($exif["EXIF"]["WhiteBalance"])) {
					switch($exif["EXIF"]["WhiteBalance"]) {
						case 0:
							$fbwhitebalance = "Auto";
							break;
						case 1:
							$fbwhitebalance = "Daylight";
							break;
						case 2:
							$fbwhitebalance = "Fluorescent";
							break;
						case 3:
							$fbwhitebalance = "Incandescent";
							break;
						case 4:
							$fbwhitebalance = "Flash";
							break;
						case 9:
							$fbwhitebalance = "Fine Weather";
							break;
						case 10:
							$fbwhitebalance = "Cloudy";
							break;
						case 11:
							$fbwhitebalance = "Shade";
							break;
						default:
							$fbwhitebalance = "";
							break;
					}
					print __(' &middot; Wei&szlig;abgleich:', 'photoblogfb') . " {$fbwhitebalance}";
				}

				if(isset($exif["EXIF"]["Flash"])) {
					$fbflash = (bindec($exif["EXIF"]["Flash"]) ? "On" : "Off");
					print __(' &middot; Blitz:', 'photoblogfb') . " {$fbflash}";
				}
				
				if(isset($exif["IFD0"]["Make"]) && isset($exif["IFD0"]["Model"])) {
					$fbmake = ucwords(strtolower($exif["IFD0"]["Make"]));
					$fbmodel = ucwords($exif["IFD0"]["Model"]);
					print "<br />\n";
					print __('Kamera/ DIA-Scanner:', 'photoblogfb') . " {$fbmake}";
					print __(',', 'photoblogfb') . " {$fbmodel}";
				}
				
				/* Alle EXIF-Daten untereinander ausgeben */
//				foreach ($exif as $key => $section) {
//					foreach ($section as $name => $val) {
//						echo "$key.$name: $val<br />\n";
//					}
//				}
			}
}


// liefert TRUE, wenn Post in Unterkategorie ist, sondt FALSE
// Example: if (is_in_category(3, 5, 7))
function is_in_category() {
	if ( func_num_args() > 0 ) {
		foreach( func_get_args() as $category ) {
			if ( in_category($category) ) {
				return( true );
			}
		}
	}
	return( false );
}


// Widget functionality
function footer_container_widget() {
	if ( function_exists('dynamic_sidebar') ) { dynamic_sidebar(2); }
}

function fb_navi_widget() {
	include (TEMPLATEPATH . '/navi.php');
}

function fb_footer_widget() {
	get_footer();
}

function fb_categories_widget($args) {
	extract($args);
	$options  = get_option('fb_categories_widget');
	$title    = empty($options['title']) ? __('Galerien') : $options['title'];
	?>
		<li><h3><a href="#" id="galerielist" title="<?php _e('&ouml;ffnen/schlie&szlig;en', 'photoblogfb'); ?>"><?php _e('&#177;', 'photoblogfb'); ?><?php echo ' ' . $title; ?></a></h3>
			<ul class="categories">
				<?php wp_list_cats('sort_column=name&optioncount=0'); ?>
			</ul>
		</li>
	<?php
}

function fb_categories_widget_control() {
	$options = $newoptions = get_option('fb_categories_widget');

	if ( $_POST['fb_categories_widget_submit'] ) {
		$newoptions['title'] = strip_tags(stripslashes($_POST['fb_categories_widget_title']));
	}

	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('fb_categories_widget', $options);
	}

	$title = attribute_escape( $options['title'] );
?>
	<p>
		<label for="fb_categories_widget" style="width: 100px; text-align: right;"><?php _e('Title:') ?>
			<input type="text" id="fb_categories_widget_title" name="fb_categories_widget_title" value="<?php echo $title ?>" />
		</label>
	</p>
	<input type="hidden" name="fb_categories_widget_submit" id="fb_categories_widget_submit" value="1" />
<?php
}

function fb_tag_widget($args) {
	extract($args);
	$options  = get_option('fb_tag_widget');
	$title    = empty($options['title']) ? __('Tags') : $options['title'];
	$smallest = empty($options['smallest']) ? '6' : $options['smallest'];
	$largest  = empty($options['largest']) ? '16' : $options['largest'];
	$format   = empty($options['format']) ? 'flat' : $options['format'];
	$number   = empty($options['number']) ? '20' : $options['number'];
	?>
	<li><h3><a href="#" id="taglist" title="<?php _e('&ouml;ffnen/schlie&szlig;en', 'photoblogfb'); ?>"><?php _e('&#177;', 'photoblogfb'); echo ' ' . $options['title']; ?></a></h3>
		<div class="tags">
			<?php wp_tag_cloud('smallest=' . $smallest . '&largest=' . $largest . '&format=' . $format . '&number=' . $number); ?>
		</div>
	</li>
	<?php
}

function fb_tag_widget_control() {
	$options = $newoptions = get_option('fb_tag_widget');

	if ( $_POST['fb_tag_widget_submit'] ) {
		$newoptions['title']    = strip_tags(stripslashes($_POST['fb_tag_widget_title']));
		$newoptions['smallest'] = strip_tags(stripslashes($_POST['fb_tag_widget_smallest']));
		$newoptions['largest']  = strip_tags(stripslashes($_POST['fb_tag_widget_largest']));
		$newoptions['format']   = strip_tags(stripslashes($_POST['fb_tag_widget_format']));
		$newoptions['number']   = strip_tags(stripslashes($_POST['fb_tag_widget_number']));
	}

	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('fb_tag_widget', $options);
	}

	$title    = attribute_escape( $options['title'] );
	$smallest = attribute_escape( $options['smallest'] );
	$largest  = attribute_escape( $options['largest'] );
	$format   = attribute_escape( $options['format'] );
	$format   = attribute_escape( $options['number'] );
?>
	<p>
		<label for="fb_tag_widget" style="width: 100px; text-align: right;"><?php _e('Title:') ?>
			<input type="text" id="fb_tag_widget_title" name="fb_tag_widget_title" value="<?php echo $title ?>" />
		</label>
	</p>
	<p>
		<label for="fb_tag_widget"><?php _e('Smallest:') ?>
			<input type="text" id="fb_tag_widget_smallest" name="fb_tag_widget_smallest" value="<?php echo $smallest ?>" />
		</label>
	</p>
	<p>
		<label for="fb_tag_widget"><?php _e('Largest:') ?>
			<input type="text" id="fb_tag_widget_largest" name="fb_tag_widget_largest" value="<?php echo $largest ?>" />
		</label>
	</p>
	<p>
		<label for="fb_tag_widget"><?php _e('Format (flat, list, array):') ?>
			<input type="text" id="fb_tag_widget_format" name="fb_tag_widget_format" value="<?php echo $format ?>" />
		</label>
	</p>
	<p>
		<label for="fb_tag_widget"><?php _e('Number:') ?>
			<input type="text" id="fb_tag_widget_number" name="fb_tag_widget_number" value="<?php echo $number ?>" />
		</label>
	</p>
	<input type="hidden" name="fb_tag_widget_submit" id="fb_tag_widget_submit" value="1" />
<?php
}

function fb_comment_widget() {
	if((is_single() || is_home()) && function_exists('fb_comments_template')) { ?>
		<li>
		<?php fb_comments_template(); ?>
		</li>
	<?php }
}

function fb_widget_register() {
	if ( function_exists('register_sidebar') ) {
		register_sidebar(array(
			'name' => 'Sidebar',
			'before_widget' => '<li>',
			'after_widget' => '</li>',
			'before_title' => '<h3 class="nontoggle">&#248; ',
			'after_title' => '</h3>',
		));
		
		register_sidebar(array(
			'name' => 'Footer',
			'before_widget' => '',
			'after_widget'  => '',
			'before_title'  => '',
			'after_title'   => '',
		));
	}
	
	register_sidebar_widget('PhotoBlog Navi', 'fb_navi_widget');
	register_sidebar_widget('PhotoBlog Footer', 'fb_footer_widget');
	
	register_sidebar_widget(__('PhotoBlog Kategorien'), 'fb_categories_widget');
	register_widget_control(__('PhotoBlog Kategorien'), 'fb_categories_widget_control', 300, 70);
	
	register_sidebar_widget(__('PhotoBlog Kommentare'), 'fb_comment_widget');
	
	register_sidebar_widget(__('PhotoBlog Tag Cloud'), 'fb_tag_widget');
	register_widget_control(__('PhotoBlog Tag Cloud'), 'fb_tag_widget_control', 300, 200);
}

add_action('widgets_init', 'fb_widget_register', 1);
?>